//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#ifndef CONFIG_H
#define CONFIG_H

// ==================================
//     compiler auto-detection
// ==================================
#define CFG_AUTO_DETECT_COMPILER	1			// 1 to autodetect compiler for PC/PS2 version

#if (CFG_AUTO_DETECT_COMPILER)
 #if (_MSC_VER >= 1100)
  #define PC_VERSION				1			// compiling with MSVC5 or higher...
  #define PS2_VERSION				0
 #else
  #define PS2_VERSION				1			// compiling with something else (hopefully ee-gcc)...
  #define PC_VERSION				0
 #endif
#else
 #define PC_VERSION					1			// 1 to enable win32 single-pass compiler
 #define PS2_VERSION				0			// 1 to enable run-time PS2 version
#endif

// =====================================================================================================
//   begin config options

#define DO_DEBUG					1			// global debug setting (advise 1 for now)

#define CFG_X86_MEMORY_SIZE			1			// amount of memory to allocate for emulation (in Mb)
#define CFG_DYNREC_COMPILE_BUF_SIZE	32			// amount of memory to allocate as an output buffer for the dynrec compiler (in Kb)
#define CFG_DYNREC_CACHE_SIZE		1024		// amount of memory to allocate for dynrec caching (in Kb)
#define CFG_DYNREC_CACHE_USE_TLB	0			// use PS2 TLB to lock code pages (to determine when invalidation is required)
#if (!CFG_DYNREC_CACHE_USE_TLB)
 #define CFG_DYNREC_CACHE_ENTRIES	128			// number of cache entries for dynrec compiler (each is 16 bytes), not used with TLB
#endif

#if (PC_VERSION)
 #define CFG_DEVICE_SUPPORT			1			// 1 to enable device support/testing
 #define CFG_CODE_LOAD_SEG			0x1000		// code load-in segment (from memory base)
 #define CFG_CODE_LOAD_OFS			0x0000		// code load-in offset  (from memory base)
#endif

#if (PS2_VERSION)
 #define SKY_VERSION				1			// 1 to enable running on PS2 SKY simulator
#endif

#endif
