//
// PS2PC: An Intel x86 emulator for MIPS R5900 (Sony PS2).
// Coded by Mike Tedder / breakpoint - bpoint@parodius.com
// http://ps2pc.parodius.com
//
// This project is released as 'open source'.  You may make any modifications
// or adjustments to the code and submit a patch to be applied to the project.
// See the web page for more details.
//
//-----------------------------------------------------------------------

#ifndef R59BASIC_H
#define R59BASIC_H

#include "types.h"

typedef enum
{
	rR0 = 0,
	rAT,
	rV0,
	rV1,
	rA0,
	rA1,
	rA2,
	rA3,
	rT0,
	rT1,
	rT2,
	rT3,
	rT4,
	rT5,
	rT6,
	rT7,
	rS0,
	rS1,
	rS2,
	rS3,
	rS4,
	rS5,
	rS6,
	rS7,
	rT8,
	rT9,
	rK0,
	rK1,
	rGP,
	rSP,
	rFP,
	rRA
} R5900_Registers;

ulong r5900ADDI(uchar rt, uchar rs, ushort immed);
ulong r5900ADDIU(uchar rt, uchar rs, ushort immed);
ulong r5900ADD(uchar rd, uchar rs, uchar rt);
ulong r5900ADDU(uchar rd, uchar rs, uchar rt);
ulong r5900OR(uchar rd, uchar rs, uchar rt);
ulong r5900ORI(uchar rt, uchar rs, ushort immed);
ulong r5900AND(uchar rd, uchar rs, uchar rt);
ulong r5900ANDI(uchar rt, uchar rs, ushort immed);
ulong r5900XOR(uchar rd, uchar rs, uchar rt);
ulong r5900XORI(uchar rt, uchar rs, ushort immed);
ulong r5900LUI(uchar rt, ushort immed);
ulong r5900SLL(uchar rd, uchar rt, uchar sa);
ulong r5900SRL(uchar rd, uchar rt, uchar sa);
ulong r5900SB(uchar rt, uchar base, ushort offset);
ulong r5900JR(uchar rs);

#endif
